package org.eclipse.jsr220orm.ui.internal.binding;

import java.util.Collection;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.jsr220orm.core.IEntityModelManager;
import org.eclipse.jsr220orm.core.options.IIntOption;
import org.eclipse.jsr220orm.metadata.EntityMetaData;

public class EntEntityTypeBinding extends EmfComboBinding {

    protected Object getValueFromModel(EObject notifier,
            EStructuralFeature feature) {
        EntityMetaData entityMetaData = (EntityMetaData) notifier;
        IEntityModelManager manager = (IEntityModelManager) entityMetaData
                .adapt(IEntityModelManager.class);
        if (manager != null) {
            return manager.getEntityMapping(entityMetaData);
        }
        return null;
    }

    protected Collection getChoiceValuesFromModel(IItemPropertyDescriptor item,
            EObject notifier) {
        EntityMetaData entityMetaData = (EntityMetaData) notifier;
        IEntityModelManager manager = (IEntityModelManager) entityMetaData
                .adapt(IEntityModelManager.class);
        if (manager != null) {
            return manager.getPossibleEntityMappings(entityMetaData);
        }
        return null;
    }

    protected void setValuesFromWidget(Object value) {
        EntityMetaData entityMetaData = (EntityMetaData) getTarget();
        IIntOption mapping = (IIntOption) value;
        IEntityModelManager manager = (IEntityModelManager) entityMetaData
                .adapt(IEntityModelManager.class);
        if (manager != null && mapping != null
                && !mapping.equals(manager.getEntityMapping(entityMetaData))) {
            manager.setEntityMapping(entityMetaData, mapping);
        }
    }

    protected String getTextFromObject(IItemLabelProvider labelProvider,
            Object value) {
        if(value == null){
            return null;
        }
        return ((IIntOption) value).getText();
    }

}
